/***********************************************
* conf.c - Read in the configuration file
* 
* CVS $Id: conf.c,v 1.5 2000/06/29 16:52:25 wcampbel Exp $
***********************************************/

#include "oper.h"

void strip(char *line)
{
	char *c;

	if ((c = strchr(line, '\n')))	*c = '\0';
	if ((c = strchr(line, '\r')))	*c = '\0';
}

void LoadConf()
{
	FILE *fp;
	char buf[BUFSIZE];
	char *s;

	if ((fp = fopen(CONFFILE, "r")) == NULL) {
		printf("Unable to open configuration file (%s)\n", CONFFILE);
		exit(0);
	}


	while (fgets(buf, BUFSIZE, fp)) {
		if (buf[0] == '#') {
			continue;
		}
		s = strtok(buf, " ");
		if (!strcmp(s, "SERVER_PORT")) {
			s = strtok(NULL, "\n");
			me.port = atoi(s);
		} else if (!strcmp(s, "CONNECT_TO")) {
			s = strtok(NULL, "\n");
			strip(s);
			memcpy(me.uplink, s, sizeof(me.uplink));
		} else if (!strcmp(s, "REALNAME")) {
			s = strtok(NULL, "\n");
			strip(s);
			memcpy(me.desc, s, sizeof(me.desc));
		} else if (!strcmp(s, "RECONNECT_TIME")) {
			s = strtok(NULL, "\n");
			me.r_time = atoi(s);
		} else if (!strcmp(s, "NICK")) {
			s = strtok(NULL, "\n");
			strip(s);
			memcpy(me.nick, s, sizeof(me.nick));
		} else if (!strcmp(s, "JOIN_CHANNEL")) {
			s = strtok(NULL, "\n");
			strip(s);
			memcpy(me.join_chan, s, sizeof(me.join_chan));
		} else if (!strcmp(s, "OP_CHANNEL")) {
			s = strtok(NULL, "\n");
			strip(s);
			memcpy(me.op_chan, s, sizeof(me.op_chan));
		} else if (!strcmp(s, "ADMINPASS")) {
			s = strtok(NULL, "\n");
			strip(s);
			memcpy(me.adpass, s, sizeof(me.adpass));
		}
	}
	fclose(fp);
}

