/*****************************************
* irc.c - IRC related subroutines
*
* CVS $Id: irc.c,v 1.11 2000/06/29 17:53:07 wcampbel Exp $
*****************************************/

#include "oper.h"

void Register()
{
	sts("USER oper 0 0 :%s", me.desc);
	sts("NICK %s", me.nick);
	op_flag = inv_flag = 0;
}

void Parse(char * buf)
{
        char *origin, *cmd, *coreLine;
        int cmdptr = 0;

        strip(buf);

        if (!(*buf))
                return;

        coreLine = strdup(buf);

#ifdef DEBUG
        log("R: %s", buf);
#endif
        origin = strtok(buf, " ");
        if (*origin == ':')
                cmdptr = 1;
        cmd = strtok(NULL, " ");

        if (cmdptr) {
                origin++;
		if (!strcmp(cmd, "PING")) {
			char * cmd = strtok(NULL, " ");
			sts("PONG :%s ", cmd);
		} else if (!strcmp(cmd, "001")) {
			sts("JOIN %s", me.join_chan);
		} else if (!strcmp(cmd, "352")) {
			char* who = NULL;
			char* vrai = NULL;
			cmd = strtok(NULL, " ");
			cmd = strtok(NULL, " ");
			cmd = strtok(NULL, " ");
                        cmd = strtok(NULL, " ");
                        cmd = strtok(NULL, " ");
                        who = strtok(NULL, " ");
                        cmd = strtok(NULL, " ");
			vrai = strchr(cmd, '*');
			if (vrai) {
				if (inv_flag) {
					sts("INVITE %s %s", who, me.op_chan);
					inv_flag = 0;
				}
				if (op_flag) {
					sts("MODE %s +o %s", me.op_chan, who);
					op_flag = 0;
				}
			}
		} else if (!strcmp(cmd, "PRIVMSG")) {
			char * target = strtok(NULL, " ");
			char * cmd = strtok(NULL, " ");
			char * p = strtok(NULL, " ");
			char * nick = strtok(origin, "!");
			cmd++;
			if (target[0] == '#') {
			} else {
				if (!strcmp(cmd, "die")) {
					Shutdown(nick, p);
				} else if (!strcmp(cmd, "restart")) {
					Restart(nick, p);
				} else if (!strcmp(cmd, "shutdown")) {
					Shutdown(nick, p);
				} else if (!strcmp(cmd, "help")) {
					PrintHelp(nick, p);
				} else if (!strcmp(cmd, "\001PING")) {
					CTCPClean(p);
					sts("NOTICE %s :\001PING %s\001",
						nick, p);
				} else if (!strcmp(cmd, "\001OP\001")) {
					op_flag = 1;
					sts("WHO %s", nick);
				} else if (!strcmp(cmd, "\001INVITE\001")) {
					inv_flag = 1;
					sts("WHO %s", nick);
				} else if (!strcmp(cmd, "\001CLIENTINFO\001")) {
					sts("NOTICE %s :\001CLIENTINFO OP INVITE PING CLIENTINFO VERSION\001", nick);
				} else if (!strcmp(cmd, "\001VERSION\001")) {
					sts("NOTICE %s :\001VERSION OperBot\001",
						nick);
				}
			}
		}
	} else {
		if (!strcmp(origin, "PING")) {
                        sts("PONG %s", cmd);
		}
	}

	free(coreLine);
}

void Shutdown(char* target, char* pass)
{
    if (pass) {
	if (!strcmp(pass, me.adpass)) {
		sts("QUIT :Shutdown by %s", target);
		close(servsock);
		exit(0);
	}
    }
    sts("PRIVMSG %s :Incorrect Password", target);
}

void Restart(char * target, char * pass)
{
    if (pass) {
	if (!strcmp(pass, me.adpass)) {
                sts("QUIT :Restart by %s", target);
                close(servsock);
		execv(SPATH, NULL);
	}
    }
    sts("PRIVMSG %s :Incorrect Password", target);
}

void PrintHelp(char * target, char * cmd)
{
	if (cmd) {
		if (!strcmp(cmd, "shutdown")) {
			sts("PRIVMSG %s :Shuts down the service (syntax: shutdown <password>)",
				target);
		} else if (!strcmp(cmd, "die")) {
			sts("PRIVMSG %s :Shuts down the service (syntax: die <password>)",
				target);
		} else if (!strcmp(cmd, "restart")) {
			sts("PRIVMSG %s :Restarts the service (syntax: restart <password>)",
				target);
		}
	} else {
		sts("PRIVMSG %s :Commands:  shutdown, die, restart, help",
		target);
	}
}
